#ifndef _CELL_H_
#define _CELL_H_
#include <stdint.h>
#include "defs.h"

struct cell_desc {
	uint32_t pos[MAX_DIMS];
	uint32_t dims;
	
	struct statements* list;
	struct cell_desc* next;
};


struct statements* new_statement(void);
void push_cell(void);
void pop_cell(void);
void free_cell_list(struct cell_desc* list);
void print_cells(void);
void print_statement_list(struct statements* list);
void print_statement(FILE* fd,struct statements* s);
void print_cell_pos(FILE* fd,struct cell_desc* cell);
const char* str_type(enum statement_type s);
const char* str_op(enum operands op);
const char* str_flag(enum branch_flags);
const char* str_invert(enum invert inv);
const char* str_wr_flag(enum write_flags wr);

#endif 