#ifndef _DEFS_H_
#define _DEFS_H_

#define MAX_DIMS 2

enum statement_type {
	s_init,
	s_add,
	s_sub,
	s_mul,
	s_div,
	s_slr,
	s_sll,
	s_and,
	s_or,
	s_nor,
	s_xor,
	s_mov,
	s_branch,
	s_switch,
	s_select,
	s_validwrite,
	s_writepolicy
};


enum operands {
	unknown,
	north,
	west,
	east,
	south,
	state,
	alu_out,
	mul_out
};

enum branch_flags {
	none,
	br_zero,
	br_negative,
	br_valid,
	br_never
};

enum invert {
	invert,
	no_invert
};

enum write_flags {
	wr_always,
	wr_valid
};

struct statements {
	enum statement_type stype;
	enum operands op1;
	enum operands op2;
	enum operands target;
	enum branch_flags flag;
	enum write_flags wr_flag;
	int data;
	int version;
	struct statements* children;
	struct statements* next;
};


#endif