%{
#include <stdio.h>
#include <stdint.h>

#include "translator.tab.h"
#define PREPRO() dump(yytext)

void dump(char* text) {
	printf("%s",text);
}
%}


%option noyywrap
%option array
%option yylineno

%%
cell		PREPRO(); return CELL;
init		PREPRO(); return INIT;
north		PREPRO(); return NORTH;
west		PREPRO(); return WEST;
east		PREPRO(); return EAST;
south		PREPRO(); return SOUTH;
state		PREPRO(); return STATE;
aluout		PREPRO(); return ALU_OUT;
mulout		PREPRO(); return MUL_OUT;
if		PREPRO(); return IF;
valid		PREPRO(); return VALID;
negative	PREPRO(); return NEGATIVE;
zero		PREPRO(); return ZERO;
switch		PREPRO(); return SWITCH;
not		PREPRO(); return NOT;
write		PREPRO(); return WRITE;
always		PREPRO(); return ALWAYS;
never		PREPRO(); return NEVER;
\+		PREPRO(); return ADD;
\-		PREPRO(); return SUB;
\*		PREPRO(); return MUL;
\/		PREPRO(); return DIV;
and		PREPRO(); return AND;
or		PREPRO(); return OR;
nor		PREPRO(); return NOR;
xor		PREPRO(); return XOR;
slr		PREPRO(); return SLR;
sll		PREPRO(); return SLL;
[0-9]+		PREPRO(); return DIGITS;
\n		printf("\n");/* Ignore newlines */
[ \t]+		/* Ingore whitespace */
.		PREPRO(); return yytext[0];
%%
