#ifndef _V1_H_
#define _V1_H_
#include <stdint.h>
#include "defs.h"

#define INVALID_SIGN		-1
#define PATH_SIZE		16

#define V1_ALU_MUX_WEST		0
#define V1_ALU_MUX_NORTH	1
#define V1_ALU_MUX_STATE	2
#define V1_ALU_MUX_MULOUT	3

#define V1_ALU_OP_ADD		0
#define V1_ALU_OP_SUB		1
#define V1_ALU_OP_SLR		2
#define V1_ALU_OP_SLL		3
#define V1_ALU_OP_OR		4
#define V1_ALU_OP_NOR		5
#define V1_ALU_OP_AND		6
#define V1_ALU_OP_XOR		7

#define V1_MD_MUX_WEST		0
#define V1_MD_MUX_NORTH		1
#define V1_MD_MUX_STATE		2
#define V1_MD_MUX_ALUOUT	3

#define V1_MD_OP_MUL		0
#define V1_MD_OP_DIV		1

#define V1_OUT_MUX_WEST		0
#define V1_OUT_MUX_NORTH	1
#define V1_OUT_MUX_STATE	2
#define V1_OUT_MUX_ALUOUT	3
#define V1_OUT_MUX_MULOUT	4

#define V1_ALU_INPUT_A_BITS	2
#define V1_ALU_INPUT_B_BITS	2
#define V1_ALU_OP_BITS		3
#define V1_MD_INPUT_A_BITS	2
#define V1_MD_INPUT_B_BITS	2
#define V1_MD_OP_BITS		1
#define V1_STATE_INPUT_BITS	3
#define V1_EAST_OUTPUT_BITS	3
#define V1_SOUTH_OUTPUT_BITS	3
#define V1_INIT_STATE_BITS	17


struct v1_part {
	int32_t alu_input_a;
	int32_t alu_input_b;
	int32_t alu_op;
	int32_t md_input_a;
	int32_t md_input_b;
	int32_t md_op;
	int32_t state_input;
	int32_t east_output;
	int32_t south_output;
	int32_t init_state;
};


int generate_v1_part(struct v1_part** target, struct statements* list);
int destroy_v1_part(struct v1_part** target);
void print_v1_part(struct v1_part* source);
void serialize_v1_part(struct v1_part* source, char* target_buffer, int version);


#endif