#ifndef _V2_H_
#define _V2_H_
#include <stdint.h>
#include "defs.h"
#include "v1.h"

#define V2_SWITCH_NO		0
#define V2_SWITCH_ZERO		1
#define V2_SWITCH_NEGATIVE	2

#define V2_OUT_VALID_STD	0
#define V2_OUT_VALID_ZERO	1
#define V2_OUT_VALID_NEGATIVE	2
#define V2_OUT_VALID_NEVER	3

#define V2_IN_SELECT_STD	0
#define V2_IN_SELECT_INV	1
#define V2_IN_SELECT_OTHER	2

#define V2_STATE_WRITE_ALWAYS	0
#define V2_STATE_WRITE_VALID	1

#define V2_SWITCH_BITS		2
#define V2_OUT_VALID_BITS	2
#define V2_IN_SELECT_BITS	2
#define V2_STATE_WRITE_BITS	1

struct v2_part {
	int32_t south_east_switch;
	int32_t east_state_switch;
	int32_t state_south_switch;
	int32_t state_valid;
	int32_t south_valid;
	int32_t east_valid;
	int32_t north_select;
	int32_t west_select;
	int32_t write_policy;
	struct v1_part* v1;
};


int generate_v2_part(struct v2_part** target, struct statements* list,int version);
int destroy_v2_part(struct v2_part** target);
void print_v2_part(struct v2_part* source, int version);
void serialize_v2_part(struct v2_part* source, char* target_buffer, int version);


#endif