#ifndef _CELL_H_
#define _CELL_H_
#include <stdint.h>

#include "counters.h"

#ifndef DATA_PORT_SIZE 
	#warning "Default data port size used"
	#define DATA_PORT_SIZE 32 /* IO-port bits*/
#endif

enum cell_config_state {
	UNCONFIGURED,
	RECONFIGURING,
	COMPUTING,
	STALLED /* ? */
};

static const char* cell_config_state_string[4] = {
	"Unconfigured",
	"Reconfiguring", 
	"Computing",
	"Stalled"
};

/* Path width in grid */
//typedef uint64_t cell_transfer;
typedef int16_t cell_transfer;
typedef uint16_t u_cell_transfer;
/* Allow wider internal state */
//typedef uint64_t cell_internal_state;
//typedef int16_t cell_internal_state;
//typedef uint16_t u_cell_internal_state;
typedef cell_transfer cell_internal_state;
typedef u_cell_transfer u_cell_internal_state;
typedef uint8_t cell_valid;

struct cell_rc_targets{
	void (*fabric)(
		int tick_number,
		cell_valid valid_north,
		cell_transfer north, 
		cell_valid valid_west,
		cell_transfer west,
		cell_valid* valid_east,
		cell_transfer* east,
		cell_valid* valid_south,
		cell_transfer* south,
		cell_valid* valid_self,
		cell_internal_state* self
	);
	cell_valid valid_state;
	cell_internal_state state;
};

typedef struct {
	enum cell_config_state config_state;
	int ticks_left;
	cell_valid register_valid_north;
	cell_transfer register_north;
	cell_valid register_valid_west;
	cell_transfer register_west;
	cell_valid result_valid_east;
	cell_transfer result_east;
	cell_valid result_valid_south;
	cell_transfer result_south;
	struct cell_rc_targets comp_state;
	struct rc_bus *config_bus;
} cell_info;

void initialize_cell(cell_info* cell);
void cell_tick(cell_info* cell, struct counters* cnt);


#endif /* !_CELL_H_ */