#ifndef _COUNTERS_H_
#define _COUNTERS_H_
#include <stdint.h>

struct counters {
	uint64_t total_memory_accesses;
	uint64_t tick_memory_accesses;
	uint64_t tick_memory_writes;
	uint64_t tick_memory_reads;
	uint64_t tick_memory_write_size;
	uint64_t tick_memory_read_size;
	uint64_t total_rc_memory_accesses;
	uint64_t tick_rc_memory_accesses;
	uint64_t tick_rc_memory_writes;
	uint64_t tick_rc_memory_reads;
	uint64_t tick_rc_memory_write_size;
	uint64_t tick_rc_memory_read_size;
	uint64_t tick_cumulative_write_size;
	uint64_t tick_cumulative_read_size;
	uint64_t total_rc_ticks;
	uint64_t tick_rc_ticks;
	uint64_t total_computation_ticks;
	uint64_t tick_computation_ticks;
};

void record_memory_write_size(struct counters* cnt,int amount);
void record_memory_read_size(struct counters* cnt,int amount);
void record_rc_memory_write_size(struct counters* cnt,int amount);
void record_rc_memory_read_size(struct counters* cnt,int amount);
void record_rc_tick(struct counters* cnt);
void record_computation_tick(struct counters* cnt);
void reset_tick_record(struct counters* cnt);


int initialize_records(char* stats_file, FILE** fd, int x, int y);
void finalize_records(FILE** fd);
void save_tick_record(FILE* fd, int tick, struct counters* cnt);

#endif /* !_COUNTERS_H_*/