#ifndef _LIBRARY_H_
#define _LIBRARY_H_
#include <stdint.h>

typedef uint32_t grid_size_t;
#define GRID_SIZE grid_size
#define GRID_DIMENTIONS grid_dims

#define INIT_SYMBOL lib_generator

typedef uint32_t memsize_t;

#define MEMORY_SYMBOL working_memory
#define MEMORY_SIZE_SYMBOL working_memory_size
#define MEMCFG_SYMBOL memory_config
#define FABRIC_SYMBOL fabric_config

#define _STRING(x) #x
#define STRING(x) _STRING(x)

struct libraries {
	const char* file_name;
	void* loaded_library;
	uint8_t* load_address;
	memsize_t memory_size;
	struct libraries* next;
};

int load_configuration(const char* file, int expected_x, 
			int expected_y, uint8_t* memory_target,
			struct libraries** list);
int unload_configuration(struct libraries** list);
int configuration_size(int expected_y, int expected_x);
int memory_configuration_size(int expected_x, int expected_y);

uint8_t* find_free_task_space(struct libraries* library, int expected_x,
				int expected_y, uint8_t* base_address);


#endif /* !_LIRARY_H_ */