#!/bin/bash

write_parameters() {
	cells_axis=$(
		cat waverpu.srp |grep "Generics, Parameters" \
			|awk -F\= '{print $2}' \
			|awk '{print $1}'
	)

	luts=$(
		cat xflow.log	|grep "Number of Slice LUTs: " \
			|awk '{print $5}' |awk -F, '{print $1$2}'
	)
	regs=$(
		cat xflow.log	|grep "Number of Slice Registers: " \
			|awk '{print $5}' |awk -F, '{print $1$2}'
	)
	config_clock=$(
		cat xflow.log	|grep TS_config_clk \
			|grep -v TIMEGRP \
			|awk -F\| '{print $4}' \
			|awk -Fn '{print $1}'
	)
	data_clock=$(
		cat xflow.log	|grep TS_data_clk \
			|grep -v TIMEGRP \
			|grep -v Derived \
			|grep -v HIGH \
			|awk -F\| '{print $4}' \
			|awk -Fn '{print $1}'
	)
	compute_clock=$(
		cat xflow.log	|grep TS_compute_clk \
			|grep -v TIMEGRP \
			|awk -F\| '{print $4}' \
			|awk -Fn '{print $1}'
	)

	echo "$(($cells_axis*$cells_axis)) $luts $regs" >> ../resources.txt
	echo "$(($cells_axis*$cells_axis)) $config_clock $data_clock $compute_clock" >> ../clocks.txt
}

echo -n "" > resources.txt
echo -n "" > clocks.txt
for i in * ; do
	if [ -d $i ]; then
		cd $i
		write_parameters
		cd ..
	fi
done
