library ieee;
use ieee.numeric_std.all;
use ieee.std_logic_1164.all;
use work.common_defs.all;

entity addersubtracter is 
	generic(
		width		: positive	:= 8
	);
	port(
		data_a		: in std_logic_vector(width-1 downto 0);
		data_b		: in std_logic_vector(width-1 downto 0);
		
		operation	: in std_logic;
		
		output		: out std_logic_vector(width-1 downto 0)
		
	);
end entity;

architecture combinatorial of addersubtracter is 
begin
	output <= std_logic_vector(signed(data_a) - signed(data_b)) 
		when operation = '1' else
		std_logic_vector(signed(data_a) + signed(data_b));
end architecture;