library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.common_defs.all;

entity mux is 
	generic(
		path_width	: positive	:= 8;
		sel_width	: positive	:= 2
	);
	port(
		input	: in std_logic_vector(((2**sel_width)*path_width)-1 downto 0);
		
		sel	: in std_logic_vector(sel_width -1  downto 0);
		output	: out std_logic_vector(path_width -1 downto 0)
	);
end entity;

architecture matrix_conv of mux is
	type matrix is array ((2**sel_width)-1 downto 0) of std_logic_vector(path_width-1 downto 0);
	signal muxin	: matrix;
begin
	array_conv: for x in (2**sel_width)-1 downto 0 generate
		path_conv: for y in path_width -1 downto 0 generate
			muxin(x)(y) <= input(x*path_width+y); 
		end generate;
	end generate;
	
	output <= muxin(to_integer(unsigned(sel)));
end architecture;