library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.common_defs.all;

entity rc_ram is
	generic(
		data_width	:positive := 38;
		addr_width	:positive := 8
	);
	port(
		clk		: in std_logic;
		
		write		: in std_logic;
		
		waddr		: in std_logic_vector(addr_width -1 downto 0);
		wdata		: in std_logic_vector(data_width -1 downto 0);
		
		raddr		: in std_logic_vector(addr_width -1 downto 0);
		rdata		: out std_logic_vector(data_width -1 downto 0)
	); 
end rc_ram;


-- VHDL from XST manual
architecture block_ram of rc_ram is 
	type ram_type is array ((2**addr_width)-1 downto 0) of std_logic_vector(data_width -1 downto 0);
	signal ram	: ram_type;
begin
	process(clk) 
	begin
		if rising_edge(clk) then
			if write = '1' then
				ram(conv_integer(waddr)) <= wdata;
			end if;
			rdata <= ram(conv_integer(raddr));
		end if;
	end process;
end architecture;