#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <time.h>

#define op_t int32_t
#define PATTERN "%c %d %d %d\n"

int main(int argc, char** argv) {
	long int vectors = 0;
	FILE* fd = NULL;
	char operation;
	op_t operand_a,operand_b,result;
	
	time_t timeseed = time(NULL);
	srand(timeseed);
	
	if ( argc != 3 ) {
		printf("Usage: %s vectors <output filname>\n",argv[0]);
		return -1;
	}
	
	errno = 0;
	vectors = strtol(argv[1],NULL,10);
	if ( errno == ERANGE || errno == EINVAL ) {
		fprintf(stderr,"Parse error: %s\n",strerror(errno));
		return -1;
	}
	
	if ( (fd = fopen(argv[2],"w")) == NULL ) {
		perror("fopen");
		return -1;
	}
	
	for (;vectors > 0 ; vectors-- ) {
		operation = rand()%2;
		operand_a = rand();
		operand_b = rand();
		
		if ( rand()%8 == 0 ) {
			operand_a = operand_a * -1;
		}
		if ( rand()%8 == 0 ) {
			operand_b = operand_b * -1;
		}
		if ( rand()%8 == 0 ) {
			operand_a = operand_a >> 16;
		}
		if ( rand()%8 == 0 ) {
			operand_b = operand_b >> 16;
		}
		
		switch (operation) {
		case 0:
			/* ADD */
			result = operand_a + operand_b;
			break;
		case 1:
			/* SUB */
			result = operand_a - operand_b;
			break;
		default:
			fprintf(stderr,"Invalid operation\n");
			return -1;
		}
		
		fprintf(fd,PATTERN,operation+'0',operand_a,operand_b,result);
	}
	fclose(fd);

	return 0;
}