#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <time.h>

#define op_t uint32_t
#define OPERANDS 4
/* Test a 4 to 1 mux */
#define PRINTFPAT "%d "

int main(int argc, char** argv) {
	long int vectors = 0;
	FILE* fd = NULL;
	int i = 0;
	char select = 0;
	op_t operands[OPERANDS] = {0,};
	op_t result = 0;
	
	time_t timeseed = time(NULL);
	srand(timeseed);
	
	if ( argc != 3 ) {
		printf("Usage: %s vectors <output filname>\n",argv[0]);
		return -1;
	}
	
	errno = 0;
	vectors = strtol(argv[1],NULL,10);
	if ( errno == ERANGE || errno == EINVAL ) {
		fprintf(stderr,"Parse error: %s\n",strerror(errno));
		return -1;
	}
	
	if ( (fd = fopen(argv[2],"w")) == NULL ) {
		perror("fopen");
		return -1;
	}
	
	for (;vectors > 0 ; vectors-- ) {
		select = (rand()%OPERANDS);
		
		for (i = 0 ; i < OPERANDS ; i++ ) {
			operands[i] = rand();
		}
		
		result = operands[select];
		
		fprintf(fd,"%c ", select+'0');
		for ( i = 0 ; i < OPERANDS ; i++ ) {
			fprintf(fd,PRINTFPAT,operands[i]);
		}
		fprintf(fd,PRINTFPAT,result);
		fprintf(fd,"\n");
	}
	fclose(fd);

	return 0;
}