#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <time.h>

#define op_t uint32_t
/* CE CI CO W DI CDO NDO */
#define PATTERN "%c %d %d %c %d %d %d\n"


int main(int argc, char** argv) {
	long int vectors = 0;
	FILE* fd = NULL;
	char config_e, write;
	op_t config_in, config_out, data_in, current_data_out = 0, new_data_out;
	op_t store = 0;
	
	time_t timeseed = time(NULL);
	srand(timeseed);
	
	if ( argc != 3 ) {
		printf("Usage: %s vectors <output filname>\n",argv[0]);
		return -1;
	}
	
	errno = 0;
	vectors = strtol(argv[1],NULL,10);
	if ( errno == ERANGE || errno == EINVAL ) {
		fprintf(stderr,"Parse error: %s\n",strerror(errno));
		return -1;
	}
	
	if ( (fd = fopen(argv[2],"w")) == NULL ) {
		perror("fopen");
		return -1;
	}
	
	for (;vectors > 0 ; vectors-- ) {
		config_e = rand()%2;
		write = rand()%2;
		config_in = rand();
		data_in = rand();
		
		current_data_out = store;
		if ( config_e == 1 ) {
			config_out = store;
			store = config_in;
		} else if ( write == 1 ) {
			store = data_in;
		} 
		new_data_out = store;
		
		fprintf(fd,PATTERN,
			config_e + '0',
			config_in,
			config_out,
			write + '0',
			data_in,
			current_data_out,
			new_data_out
		);
	}
	fclose(fd);

	return 0;
}