#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <time.h>

#define op_t uint32_t
#define PATTERN "%c %c %c %d %c %d\n"
//#define PATTERN "%c %c %c %X %c %X\n"

int main(int argc, char** argv) {
	long int vectors = 0;
	FILE* fd = NULL;
	char shift_left, shift_right, carry_in, carry_out;
	op_t operand_a,result;
	
	time_t timeseed = time(NULL);
	srand(timeseed);
	
	if ( argc != 3 ) {
		printf("Usage: %s vectors <output filname>\n",argv[0]);
		return -1;
	}
	
	errno = 0;
	vectors = strtol(argv[1],NULL,10);
	if ( errno == ERANGE || errno == EINVAL ) {
		fprintf(stderr,"Parse error: %s\n",strerror(errno));
		return -1;
	}
	
	if ( (fd = fopen(argv[2],"w")) == NULL ) {
		perror("fopen");
		return -1;
	}
	
	for (;vectors > 0 ; vectors-- ) {
		shift_left = (rand()%2);
		shift_right = (rand()%2);
		carry_in = (rand()%2);
		operand_a = rand();
		
		if ( rand()%4 == 0 ) {
			operand_a = operand_a * -1;
		}
		
		if ( rand()%4 == 0 ) {
			/* Force som smaller shift-targets */
			operand_a = operand_a % (2<<16);
		}
		
		/* Shift-left is dominating */
		if ( shift_left == 1 ) {
			result = (operand_a<<1) | carry_in&0x1;
			if ( operand_a & ~( (((op_t)0)-1)>>1 ) ) {
				/* Carry out */
				carry_out = 1;
			} else {
				carry_out = 0;
			}
		} else if ( shift_right == 1 ) {
			result = (operand_a>>1) | (carry_in&0x1)<<31;
			if ( operand_a & 0x01 ) {
				carry_out = 1;
			} else {
				carry_out = 0;
			}
		} else {
			result = operand_a;
			carry_out = 0;
		}
		fprintf(fd,PATTERN,shift_left+'0',shift_right+'0',carry_in+'0',operand_a,carry_out+'0',result);
	}
	fclose(fd);

	return 0;
}