#!/bin/bash

convert_bit_file() {
	echo "Converting $3"
	bit_file=$3
	
	header=$(cat $bit_file |head -n1)
	echo "Header: $header"
	version=$(echo $header | cut -c 1-4)
	echo "Version: $version"
	flags=$(echo $header | cut -c 5-8)
	echo "Flags: $flags"
	y_size=$(echo $header | cut -c 9-16)
	x_size=$(echo $header | cut -c 17-24)
	y_dec_size=$(echo 0b$y_size |wcalc -d |awk -F\= '{print $2}')
	x_dec_size=$(echo 0b$x_size |wcalc -d |awk -F\= '{print $2}')
	echo "X: $x_dec_size ($x_size) Y: $y_dec_size ($y_size)"
	
	echo "put /auto_wrpu_testbench/uut/rcm_ram/ram($(($1*$y_dec_size))) $header" >> isim-commands.txt
	for i in $(seq 0 $(($x_dec_size-1))); do
		for j in $(seq 1 $(($y_dec_size))) ; do
			echo $((($i*($y_dec_size))+1+j))
			li=$((($i*($y_dec_size))+1+j))
			conf_line=$(cat $bit_file |head --lines=$li |tail -n1)
			spacing=$(($WRPU_X_SIZE/$x_dec_size))
			ram=$(($spacing*$i))
			
			echo "put /auto_wrpu_testbench/uut/\\\\rc_rams($ram)\\\\/rcram/ram($(((j-1)+($y_dec_size*$1)))) $conf_line" >> isim-commands.txt
		done
	done
}

echo $#
echo "" > isim-commands.txt
#X-size
o_rom_size=$(echo "2**ceil(logtwo($WRPU_X_SIZE+1))" |wcalc |awk -F\= '{print $2}')
#nuke offset rom
echo $o_rom_size
for i in $(seq 0 $(($o_rom_size-1))); do
	echo "put /auto_wrpu_testbench/uut/rcm/offset_rom/data_rom($i) 00000000" >> isim-commands.txt
done

configs=0
for i in $@ ; do
	convert_bit_file $configs 0 $i
	configs=$((configs+1))
done
echo "run all" >> isim-commands.txt

