#!/bin/bash

configs=0

convert_bit_file() {
	echo "Converting $3"
	bit_file=$3
	
	header=$(cat $bit_file |head -n1)
	echo "Header: $header"
	version=$(echo $header | cut -c 1-4)
	version_dec=$(echo 0b$version | wcalc -d |awk -F\= '{print $2}')
	echo "Version: $version_dec ($version)"
	flags=$(echo $header | cut -c 5-8)
	echo "Flags: $flags"
	y_size=$(echo $header | cut -c 9-16)
	x_size=$(echo $header | cut -c 17-24)
	y_dec_size=$(echo 0b$y_size |wcalc -d |awk -F\= '{print $2}')
	x_dec_size=$(echo 0b$x_size |wcalc -d |awk -F\= '{print $2}')
	echo "X: $x_dec_size ($x_size) Y: $y_dec_size ($y_size)"
	
	echo "put /auto_wrpu_testbench/uut/rcm_ram/ram($(($1*$y_dec_size))) $header" >> isim-commands.txt
	
	for i in $(seq 0 $(($x_dec_size-1))); do
		for j in $(seq 1 $(($y_dec_size))) ; do
			echo $((($i*($y_dec_size))+1+j))
			li=$((($i*($y_dec_size))+1+j))
			conf_line=$(cat $bit_file |head --lines=$li |tail -n1)
			spacing=$(($WRPU_X_SIZE/$x_dec_size))
			ram=$(($spacing*$i))
			
			if [ $version_dec -eq 1 ]; then
				c1=$(echo $conf_line |cut -c 20-57)
				c2=$(echo $conf_line |cut -c 1-19)
				c2=$(echo "1111111111111111111"$c2)
				target_pos=$(($j*($version+1)))
				echo "put /auto_wrpu_testbench/uut/\\\\rc_rams($ram)\\\\/rcram/ram($((($target_pos-2)+($y_dec_size*$1)))) $c1" >> isim-commands.txt
				echo "put /auto_wrpu_testbench/uut/\\\\rc_rams($ram)\\\\/rcram/ram($((($target_pos-1)+($y_dec_size*$1)))) $c2" >> isim-commands.txt
			
			else 
				echo "put /auto_wrpu_testbench/uut/\\\\rc_rams__$ram/rcram/ram($((($j-1)+($y_dec_size*$1)))) $conf_line" >> isim-commands.txt
			
			fi
		done
	done
	configs=$(($configs+($version+1)))
}

echo $#
echo "" > isim-commands.txt
#X-size

#Nuke offset rom
o_rom_size=$(echo "2**ceil(logtwo($WRPU_X_SIZE+1))" |wcalc |awk -F\= '{print $2}')
echo $o_rom_size
for i in $(seq 0 $(($o_rom_size-1))); do
	echo "put /auto_wrpu_testbench/uut/rcm/v1_offset_rom/data_rom($i) 00000000" >> isim-commands.txt
	echo "put /auto_wrpu_testbench/uut/rcm/v2_offset_rom/data_rom($i) 00000000" >> isim-commands.txt
done

#Convert bit files 
for i in $@ ; do
	convert_bit_file $configs 0 $i
done
echo "run all" >> isim-commands.txt

